Index: /branches/proxy/src/lib/network/monitor/network_monitor.h
===================================================================
--- /branches/proxy/src/lib/network/monitor/network_monitor.h	(revision 9640)
+++ /branches/proxy/src/lib/network/monitor/network_monitor.h	(revision 9641)
@@ -64,5 +64,5 @@
 
     /** @returns the active proxy server list of the localnode */
-    inline std::list<NetworkNode*> getActiveProxyServer() const { return this->localNode->getActiveProxyServer(); }
+    inline std::list<NetworkNode*> getActiveProxyServers() const { return this->localNode->getActiveProxyServers(); }
 
     /* slots admin and info interface */
Index: /branches/proxy/src/lib/network/monitor/network_node.cc
===================================================================
--- /branches/proxy/src/lib/network/monitor/network_node.cc	(revision 9640)
+++ /branches/proxy/src/lib/network/monitor/network_node.cc	(revision 9641)
@@ -418,11 +418,8 @@
   if( !this->masterServerList.empty())
   {
-//     PRINT(0)("%s + master servers: %i\n", indent, this->masterServerList.size());
     it = this->masterServerList.begin();
 
     for(; it != this->masterServerList.end(); it++)
     {
-//       IP* ip = &(*it)->getPeerInfo()->ip;
-//       PRINT(0)("%s     - ms, id: %i (%s)\n", indent, (*it)->getPeerInfo()->userId, ip->ipString().c_str());
       (*it)->debug(depth+1);
     }
@@ -431,11 +428,8 @@
   if( !this->activeProxyServerList.empty())
   {
-//     PRINT(0)("%s + proxy servers active: %i\n", indent, this->activeProxyServerList.size());
     it = this->activeProxyServerList.begin();
 
     for(; it != this->activeProxyServerList.end(); it++)
     {
-//       IP* ip = &(*it)->getPeerInfo()->ip;
-//       PRINT(0)("%s     - ps-a, id: %i (%s)\n", indent, (*it)->getPeerInfo()->userId, ip->ipString().c_str());
       (*it)->debug(depth+1);
     }
@@ -445,11 +439,8 @@
   if( !this->passiveProxyServerList.empty())
   {
-//     PRINT(0)("%s proxy servers passive: %i\n", indent, this->passiveProxyServerList.size());
     it = this->passiveProxyServerList.begin();
 
     for(; it != this->passiveProxyServerList.end(); it++)
     {
-//       IP* ip = &(*it)->getPeerInfo()->ip;
-//       PRINT(0)("%s     - ps-p, id: %i (%s)\n", indent, (*it)->getPeerInfo()->userId, ip->ipString().c_str());
       (*it)->debug(depth+1);
     }
@@ -458,11 +449,8 @@
   if( !this->clientList.empty())
   {
-//     PRINT(0)("%s clients: %i\n", indent, this->clientList.size());
     it = this->clientList.begin();
 
     for(; it != this->clientList.end(); it++)
     {
-//       IP* ip = &(*it)->getPeerInfo()->ip;
-//       PRINT(0)("%s     - client, id: %i (%s)\n", indent, (*it)->getPeerInfo()->userId, ip->ipString().c_str());
       (*it)->debug(depth+1);
     }
Index: /branches/proxy/src/lib/network/monitor/network_node.h
===================================================================
--- /branches/proxy/src/lib/network/monitor/network_node.h	(revision 9640)
+++ /branches/proxy/src/lib/network/monitor/network_node.h	(revision 9641)
@@ -43,11 +43,11 @@
 
     /** @returns the master server list */
-    inline std::list<NetworkNode*> getMasterServer() const { return this->masterServerList; }
+    inline std::list<NetworkNode*> getMasterServers() const { return this->masterServerList; }
     /** @returns the active proxy server list */
-    inline std::list<NetworkNode*> getActiveProxyServer() const { return this->activeProxyServerList; }
+    inline std::list<NetworkNode*> getActiveProxyServers() const { return this->activeProxyServerList; }
     /** @returns the passive proxy server list */
-    inline std::list<NetworkNode*> getPassiveProxyServer() const { return this->passiveProxyServerList; }
+    inline std::list<NetworkNode*> getPassiveProxyServers() const { return this->passiveProxyServerList; }
     /** @returns the client list */
-    inline std::list<NetworkNode*> getClient() const { return this->clientList; }
+    inline std::list<NetworkNode*> getClients() const { return this->clientList; }
 
     PeerInfo* getPeerByUserId( int userId);