Index: code/branches/core6/src/libraries/core/class/IdentifierManager.h
===================================================================
--- code/branches/core6/src/libraries/core/class/IdentifierManager.h	(revision 9641)
+++ code/branches/core6/src/libraries/core/class/IdentifierManager.h	(revision 9642)
@@ -47,15 +47,16 @@
             static IdentifierManager& getInstance();
 
-            /////////////////////////////
-            ////// Class Hierarchy //////
-            /////////////////////////////
             Identifier* getIdentifierSingleton(const std::string& name, Identifier* proposal);
+            void registerIdentifier(Identifier* identifier);
 
             unsigned int getUniqueClassId()
                 { return this->classIDCounter_s++; }
 
-            void registerIdentifier(Identifier* identifier);
 
+            /////////////////////////////
+            ////// Class Hierarchy //////
+            /////////////////////////////
             void createClassHierarchy();
+            void destroyAllIdentifiers();
 
             /// Returns true, if a branch of the class-hierarchy is being created, causing all new objects to store their parents.
@@ -67,6 +68,4 @@
             ///// Identifier Map /////
             //////////////////////////
-            void destroyAllIdentifiers();
-
             Identifier* getIdentifierByString(const std::string& name);
             Identifier* getIdentifierByLowercaseString(const std::string& name);
@@ -76,32 +75,12 @@
 
             /// Returns the map that stores all Identifiers with their names.
-            inline const std::map<std::string, Identifier*>& getStringIdentifierMap()
+            inline const std::map<std::string, Identifier*>& getIdentifierByStringMap()
                 { return this->identifierByString_; }
-            /// Returns a const_iterator to the beginning of the map that stores all Identifiers with their names.
-            inline std::map<std::string, Identifier*>::const_iterator getStringIdentifierMapBegin()
-                { return this->identifierByString_.begin(); }
-            /// Returns a const_iterator to the end of the map that stores all Identifiers with their names.
-            inline std::map<std::string, Identifier*>::const_iterator getStringIdentifierMapEnd()
-                { return this->identifierByString_.end(); }
-
             /// Returns the map that stores all Identifiers with their names in lowercase.
-            inline const std::map<std::string, Identifier*>& getLowercaseStringIdentifierMap()
+            inline const std::map<std::string, Identifier*>& getIdentifierByLowercaseStringMap()
                 { return this->identifierByLowercaseString_; }
-            /// Returns a const_iterator to the beginning of the map that stores all Identifiers with their names in lowercase.
-            inline std::map<std::string, Identifier*>::const_iterator getLowercaseStringIdentifierMapBegin()
-                { return this->identifierByLowercaseString_.begin(); }
-            /// Returns a const_iterator to the end of the map that stores all Identifiers with their names in lowercase.
-            inline std::map<std::string, Identifier*>::const_iterator getLowercaseStringIdentifierMapEnd()
-                { return this->identifierByLowercaseString_.end(); }
-
             /// Returns the map that stores all Identifiers with their IDs.
-            inline const std::map<uint32_t, Identifier*>& getIDIdentifierMap()
+            inline const std::map<uint32_t, Identifier*>& getIdentifierByNetworkIdMap()
                 { return this->identifierByNetworkId_; }
-            /// Returns a const_iterator to the beginning of the map that stores all Identifiers with their IDs.
-            inline std::map<uint32_t, Identifier*>::const_iterator getIDIdentifierMapBegin()
-                { return this->identifierByNetworkId_.begin(); }
-            /// Returns a const_iterator to the end of the map that stores all Identifiers with their IDs.
-            inline std::map<uint32_t, Identifier*>::const_iterator getIDIdentifierMapEnd()
-                { return this->identifierByNetworkId_.end(); }
 
         private:
Index: code/branches/core6/src/libraries/network/packet/ClassID.cc
===================================================================
--- code/branches/core6/src/libraries/network/packet/ClassID.cc	(revision 9641)
+++ code/branches/core6/src/libraries/network/packet/ClassID.cc	(revision 9642)
@@ -55,6 +55,6 @@
 
   //calculate total needed size (for all strings and integers)
-  std::map<std::string, Identifier*>::const_iterator it = IdentifierManager::getInstance().getStringIdentifierMapBegin();
-  for(;it != IdentifierManager::getInstance().getStringIdentifierMapEnd();++it){
+  std::map<std::string, Identifier*>::const_iterator it = IdentifierManager::getInstance().getIdentifierByStringMap().begin();
+  for(;it != IdentifierManager::getInstance().getIdentifierByStringMap().end();++it){
     id = it->second;
     if(id == NULL || !id->hasFactory())