Index: branches/proxy/src/lib/network/monitor/network_stats_widget.cc
===================================================================
--- branches/proxy/src/lib/network/monitor/network_stats_widget.cc	(revision 9648)
+++ branches/proxy/src/lib/network/monitor/network_stats_widget.cc	(revision 9649)
@@ -91,5 +91,5 @@
     : _proxyWidget(proxyName, ip)
 {
-  this->_clientNameWidth = 100.0f;
+  this->_nodeNameWidth = 100.0f;
   this->pack(&_proxyWidget);
 }
@@ -98,13 +98,39 @@
     : _proxyWidget(node->getPeerInfo())// "node", node->getPeerInfo()->ip)
 {
-  this->_clientNameWidth = 100.0f;
+  this->_nodeNameWidth = 100.0f;
   this->pack(&_proxyWidget);
-}
-
-
-void NodeWidget::addClient(const std::string& name, const IP& ip)
+
+  std::list<NetworkNode*> list = node->getMasterServers();
+  std::list<NetworkNode*>::const_iterator it;
+
+  for(it = list.begin(); it != list.end(); it++)
+    this->addNode(*it);
+
+  list = node->getActiveProxyServers();
+  for(it = list.begin(); it != list.end(); it++)
+    this->addNode(*it);
+
+  list = node->getPassiveProxyServers();
+  for(it = list.begin(); it != list.end(); it++)
+    this->addNode(*it);
+
+  list = node->getClients();
+  for(it = list.begin(); it != list.end(); it++)
+    this->addNode(*it);
+}
+
+
+void NodeWidget::addNode(const NetworkNode* node)
+{
+  this->_nodes.push_back(new NodeWidget(node));
+  this->pack(this->_nodes.back());
+  this->_nodes.back()->show();
+}
+
+
+void NodeWidget::addNode(const std::string& name, const IP& ip)
 {
   HostWidget* newClient = new HostWidget(name, ip);
-  newClient->setNameWidth(this->_clientNameWidth);
+  newClient->setNameWidth(this->_nodeNameWidth);
 
   this->pack(newClient);
@@ -114,56 +140,56 @@
 }
 
-bool NodeWidget::removeClient(const IP& ip)
-{
-  std::vector<HostWidget*>::iterator rmIt;
-  for(rmIt = this->_clients.begin(); rmIt != this->_clients.end(); ++rmIt)
-  {
-    if (*(*rmIt) == ip)
-    {
-      delete (*rmIt);
-      this->_clients.erase(rmIt);
-      return true;
-    }
-  }
-  return false;
-}
-
-bool NodeWidget::removeClient(const std::string& name)
-{
-  std::vector<HostWidget*>::iterator rmIt;
-  for(rmIt = this->_clients.begin(); rmIt != this->_clients.end(); ++rmIt)
-  {
-    if (*(*rmIt) == name)
-    {
-      delete (*rmIt);
-      this->_clients.erase(rmIt);
-      return true;
-    }
-  }
-  return false;
-
-}
-
-bool NodeWidget::removeClient(const std::string& name, const IP& ip)
-{
-  std::vector<HostWidget*>::iterator rmIt;
-  for(rmIt = this->_clients.begin(); rmIt != this->_clients.end(); ++rmIt)
-  {
-    if (*(*rmIt) == ip && *(*rmIt) == name)
-    {
-      delete (*rmIt);
-      this->_clients.erase(rmIt);
-      return true;
-    }
-  }
-  return false;
-}
-
-
-void NodeWidget::setClientNameWidths(float width)
-{
-  this->_clientNameWidth = width;
-  for (unsigned int i = 0; i < this->_clients.size(); ++i)
-    this->_clients[i]->setNameWidth(width);
+bool NodeWidget::removeNode(const IP& ip)
+{
+//   std::vector<HostWidget*>::iterator rmIt;
+//   for(rmIt = this->_nodes.begin(); rmIt != this->_nodes.end(); ++rmIt)
+//   {
+//     if (*(*rmIt) == ip)
+//     {
+//       delete (*rmIt);
+//       this->_nodes.erase(rmIt);
+//       return true;
+//     }
+//   }
+//   return false;
+}
+
+bool NodeWidget::removeNode(const std::string& name)
+{
+//   std::vector<HostWidget*>::iterator rmIt;
+//   for(rmIt = this->_nodes.begin(); rmIt != this->_nodes.end(); ++rmIt)
+//   {
+//     if (*(*rmIt) == name)
+//     {
+//       delete (*rmIt);
+//       this->_nodes.erase(rmIt);
+//       return true;
+//     }
+//   }
+//   return false;
+
+}
+
+bool NodeWidget::removeNode(const std::string& name, const IP& ip)
+{
+//   std::vector<HostWidget*>::iterator rmIt;
+//   for(rmIt = this->_nodes.begin(); rmIt != this->_nodes.end(); ++rmIt)
+//   {
+//     if (*(*rmIt) == ip && *(*rmIt) == name)
+//     {
+//       delete (*rmIt);
+//       this->_nodes.erase(rmIt);
+//       return true;
+//     }
+//   }
+//   return false;
+}
+
+
+void NodeWidget::setNodeNameWidths(float width)
+{
+/*  this->_nodeNameWidth = width;
+  for (unsigned int i = 0; i < this->_nodes.size(); ++i)
+    this->_nodes[i]->setNameWidth(width);*/
 }
 
@@ -171,6 +197,6 @@
 {
   this->_proxyWidget.hide();
-  for (unsigned int i = 0; i < this->_clients.size(); ++i)
-    this->_clients[i]->hide();
+  for (unsigned int i = 0; i < this->_nodes.size(); ++i)
+    this->_nodes[i]->hide();
 }
 
@@ -178,6 +204,6 @@
 {
   this->_proxyWidget.show();
-  for (unsigned int i = 0; i < this->_clients.size(); ++i)
-    this->_clients[i]->show();
+  for (unsigned int i = 0; i < this->_nodes.size(); ++i)
+    this->_nodes[i]->show();
 }
 
@@ -311,23 +337,4 @@
 
   this->addNode(node);
-
-  std::list<NetworkNode*> list = node->getMasterServers();
-  std::list<NetworkNode*>::const_iterator it;
-
-  for(it = list.begin(); it != list.end(); it++)
-    this->addNode(*it);
-
-  list = node->getActiveProxyServers();
-  for(it = list.begin(); it != list.end(); it++)
-    this->addNode(*it);
-
-  list = node->getPassiveProxyServers();
-  for(it = list.begin(); it != list.end(); it++)
-    this->addNode(*it);
-
-  list = node->getClients();
-  for(it = list.begin(); it != list.end(); it++)
-    this->addNode(*it);
-
 }
 
Index: branches/proxy/src/lib/network/monitor/network_stats_widget.h
===================================================================
--- branches/proxy/src/lib/network/monitor/network_stats_widget.h	(revision 9648)
+++ branches/proxy/src/lib/network/monitor/network_stats_widget.h	(revision 9649)
@@ -53,12 +53,12 @@
     NodeWidget(const NetworkNode* node);
 
-    void addClient(const NetworkNode* node);
-    void addClient(const std::string& name, const IP& ip);
+    void addNode(const NetworkNode* node);
+    void addNode(const std::string& name, const IP& ip);
 
-    bool removeClient(const IP& ip);
-    bool removeClient(const std::string& name);
-    bool removeClient(const std::string& name, const IP& ip);
+    bool removeNode(const IP& ip);
+    bool removeNode(const std::string& name);
+    bool removeNode(const std::string& name, const IP& ip);
 
-    void setClientNameWidths(float width);
+    void setNodeNameWidths(float width);
 
 
@@ -71,6 +71,6 @@
     HostWidget                _proxyWidget;
 
-    std::vector<HostWidget*>  _clients;
-    float                     _clientNameWidth;
+    std::vector<NodeWidget*>  _nodes;
+    float                     _nodeNameWidth;
 };
 