Index: code/branches/core6/src/libraries/core/config/CMakeLists.txt
===================================================================
--- code/branches/core6/src/libraries/core/config/CMakeLists.txt	(revision 9652)
+++ code/branches/core6/src/libraries/core/config/CMakeLists.txt	(revision 9653)
@@ -6,4 +6,5 @@
   ConfigFileManager.cc
   ConfigFileSection.cc
+  Configurable.cc
   ConfigValueContainer.cc
   SettingsConfigFile.cc
Index: code/branches/core6/src/libraries/core/config/Configurable.cc
===================================================================
--- code/branches/core6/src/libraries/core/config/Configurable.cc	(revision 9653)
+++ code/branches/core6/src/libraries/core/config/Configurable.cc	(revision 9653)
@@ -0,0 +1,40 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "Configurable.h"
+#include "core/CoreIncludes.h"
+
+namespace orxonox
+{
+    RegisterClassNoArgs(Configurable);
+
+    Configurable::Configurable()
+    {
+        RegisterObject(Configurable);
+    }
+}
Index: code/branches/core6/src/libraries/core/config/Configurable.h
===================================================================
--- code/branches/core6/src/libraries/core/config/Configurable.h	(revision 9652)
+++ code/branches/core6/src/libraries/core/config/Configurable.h	(revision 9653)
@@ -48,4 +48,6 @@
     {
         public:
+            Configurable();
+
             /// Function to collect the SetConfigValue-macro calls.
             void setConfigValues() {};
Index: code/branches/core6/test/core/class/IdentifierClassHierarchyTest.cc
===================================================================
--- code/branches/core6/test/core/class/IdentifierClassHierarchyTest.cc	(revision 9652)
+++ code/branches/core6/test/core/class/IdentifierClassHierarchyTest.cc	(revision 9653)
@@ -132,4 +132,5 @@
                     registerClass("Context", new ClassFactoryWithContext<Context>());
                     registerClass("Listable", new ClassFactoryWithContext<Listable>());
+                    registerClass("Configurable", new ClassFactoryNoArgs<Configurable>());
                     registerClass("OrxonoxInterface", new ClassFactoryNoArgs<OrxonoxInterface>());
                     registerClass("OrxonoxClass", new ClassFactoryNoArgs<OrxonoxClass>());
@@ -232,7 +233,8 @@
         EXPECT_TRUE(contains(identifier->getDirectParents(), Class(OrxonoxInterface)));
 
-        EXPECT_EQ(3u, identifier->getParents().size());
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_EQ(4u, identifier->getParents().size());
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Configurable)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(OrxonoxInterface)));
     }
@@ -255,7 +257,8 @@
         EXPECT_TRUE(contains(identifier->getDirectParents(), Class(OrxonoxInterface)));
 
-        EXPECT_EQ(3u, identifier->getParents().size());
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_EQ(4u, identifier->getParents().size());
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Configurable)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(OrxonoxInterface)));
     }
@@ -278,7 +281,8 @@
         EXPECT_TRUE(contains(identifier->getDirectParents(), Class(BaseInterface1)));
 
-        EXPECT_EQ(4u, identifier->getParents().size());
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_EQ(5u, identifier->getParents().size());
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Configurable)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(OrxonoxInterface)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(BaseInterface1)));
@@ -300,7 +304,8 @@
         EXPECT_TRUE(contains(identifier->getDirectParents(), Class(BaseInterface2)));
 
-        EXPECT_EQ(4u, identifier->getParents().size());
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_EQ(5u, identifier->getParents().size());
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Configurable)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(OrxonoxInterface)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(BaseInterface2)));
@@ -328,7 +333,8 @@
         EXPECT_TRUE(contains(identifier->getDirectParents(), Class(OrxonoxClass)));
 
-        EXPECT_EQ(3u, identifier->getParents().size());
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_EQ(4u, identifier->getParents().size());
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Configurable)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(OrxonoxClass)));
     }
@@ -345,7 +351,8 @@
         EXPECT_TRUE(contains(identifier->getDirectParents(), Class(BaseClass)));
 
-        EXPECT_EQ(4u, identifier->getParents().size());
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_EQ(5u, identifier->getParents().size());
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Configurable)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(OrxonoxClass)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(BaseClass)));
@@ -364,7 +371,8 @@
         EXPECT_TRUE(contains(identifier->getDirectParents(), Class(Interface1)));
 
-        EXPECT_EQ(7u, identifier->getParents().size());
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_EQ(8u, identifier->getParents().size());
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Configurable)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(OrxonoxClass)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(BaseClass)));
@@ -387,7 +395,8 @@
         EXPECT_TRUE(contains(identifier->getDirectParents(), Class(Interface2)));
 
-        EXPECT_EQ(9u, identifier->getParents().size());
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_EQ(10u, identifier->getParents().size());
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Configurable)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(OrxonoxClass)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(BaseClass)));
@@ -412,7 +421,8 @@
         EXPECT_TRUE(contains(identifier->getDirectParents(), Class(Interface2)));
 
-        EXPECT_EQ(9u, identifier->getParents().size());
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_EQ(10u, identifier->getParents().size());
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Configurable)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(OrxonoxClass)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(BaseClass)));
@@ -437,7 +447,8 @@
         EXPECT_TRUE(contains(identifier->getDirectParents(), Class(BaseInterface2)));
 
-        EXPECT_EQ(7u, identifier->getParents().size());
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
-        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_EQ(8u, identifier->getParents().size());
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Configurable)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(OrxonoxClass)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(BaseClass)));
Index: code/branches/core6/test/core/class/IdentifierExternalClassHierarchyTest.cc
===================================================================
--- code/branches/core6/test/core/class/IdentifierExternalClassHierarchyTest.cc	(revision 9652)
+++ code/branches/core6/test/core/class/IdentifierExternalClassHierarchyTest.cc	(revision 9653)
@@ -44,4 +44,6 @@
                 virtual void SetUp()
                 {
+                    registerClass("Context", new ClassFactoryWithContext<Context>());
+                    registerClass("Listable", new ClassFactoryWithContext<Listable>());
                     registerClass("Interface", static_cast<ClassFactory<Interface>*>(NULL), false).inheritsFrom(Class(Identifiable));
                     registerClass("BaseClass", new ClassFactoryNoArgs<BaseClass>());
Index: code/branches/core6/test/core/class/IdentifierSimpleClassHierarchyTest.cc
===================================================================
--- code/branches/core6/test/core/class/IdentifierSimpleClassHierarchyTest.cc	(revision 9652)
+++ code/branches/core6/test/core/class/IdentifierSimpleClassHierarchyTest.cc	(revision 9653)
@@ -48,4 +48,5 @@
                     registerClass("Context", new ClassFactoryWithContext<Context>());
                     registerClass("Listable", new ClassFactoryWithContext<Listable>());
+                    registerClass("Configurable", new ClassFactoryNoArgs<Configurable>());
                     registerClass("OrxonoxInterface", new ClassFactoryNoArgs<OrxonoxInterface>());
                     registerClass("OrxonoxClass", new ClassFactoryNoArgs<OrxonoxClass>());
@@ -101,7 +102,8 @@
         EXPECT_TRUE(contains(identifier->getDirectParents(), Class(OrxonoxInterface)));
 
-        EXPECT_EQ(3u, identifier->getParents().size());
+        EXPECT_EQ(4u, identifier->getParents().size());
         EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Configurable)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(OrxonoxInterface)));
     }
@@ -120,7 +122,8 @@
         EXPECT_TRUE(contains(identifier->getDirectParents(), Class(OrxonoxClass)));
 
-        EXPECT_EQ(3u, identifier->getParents().size());
+        EXPECT_EQ(4u, identifier->getParents().size());
         EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Configurable)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(OrxonoxClass)));
     }
@@ -138,7 +141,8 @@
         EXPECT_TRUE(contains(identifier->getDirectParents(), Class(BaseClass)));
 
-        EXPECT_EQ(6u, identifier->getParents().size());
+        EXPECT_EQ(7u, identifier->getParents().size());
         EXPECT_TRUE(contains(identifier->getParents(), Class(Identifiable)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(Listable)));
+        EXPECT_TRUE(contains(identifier->getParents(), Class(Configurable)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(OrxonoxInterface)));
         EXPECT_TRUE(contains(identifier->getParents(), Class(OrxonoxClass)));